const router = require('express').Router();
const express = require('express');
const qrcode = require('qrcode-terminal');

const fs = require("fs");


const { Client } = require('whatsapp-web.js');
const { Server } = require('http');
const client = new Client();

const app = express()
//const port = 3000

var port = process.env.PORT;// || 3000;

app.use(express.json());
app.use(express.urlencoded({ extended: true }));

app.get('/', (req, res) => {
    res.send('Hello World!')
  })
  
  app.get('/Test', (req, res) => {
    res.send('Hello  Test World!')
  })

//   app.param('name', function(req, res, next, name) {
//     const modified = name.toUpperCase();
  
//     req.name = modified;
//     next();
//   });

//   app.get('/Test/:name', function(req, res) {
//     res.send('Hello ' + req.name + '!');
//   });

//   app.get('/Test1/:name1', function(req, res) {
//     res.send('Hello1 ' + req.params.name1 + '!');
//   });

  app.get('/close', (req, res) => {
      console.log(req);
      app.close();
  })

  app.listen(port, () => {
    console.log(`Example app listening on port ${port}`)

    fs.writeFileSync("last.qr", "");

  })




//   app.post('/process_post',  function (req, res) {  
//     // Prepare output in JSON format  
//     response = {  
//         first_name:req.body.first_name,  
//         last_name:req.body.last_name  
//     };  
//     console.log(response);  
//     res.end(JSON.stringify(response));  
//  })  

client.on('qr', qr => {
  
  qrcode.generate(qr, {small: true});
  console.log('Client qr');
  fs.writeFileSync("last.qr", "");  
  fs.writeFileSync("last.qr", qr);
  
  //res.write("<html><body><h2>Get Qr</h2></body></html>");

    

    // app.get('/getqr', (req, res) => {
    //   res.send({ qr });
    // });

});

app.get("/getqr", async (req, res) => {

    console.log('1 QR RECEIVED');
  
    client
      .getState()
      .then((data) => {
        if (data) {
          res.write("<html><body><h2>Already Authenticated</h2></body></html>");
          res.end();
        } else 
        sendQr(res);
      })
      .catch(() => sendQr(res));
  });
  

  function sendQr(res) {
     fs.readFile("last.qr", (err, last_qr) => {
  
      if (last_qr!='')
{
      console.log('last_qr : ' + last_qr);
      if (!err && last_qr) {
        var page = `
                      <html>
                          <body>
                              <script type="module">
                              </script>
                              <div id="qrcode"></div>
                              <script type="module">
                                  import QrCreator from "https://cdn.jsdelivr.net/npm/qr-creator/dist/qr-creator.es6.min.js";
                                  let container = document.getElementById("qrcode");
                                  QrCreator.render({
                                      text: "${last_qr}",
                                      radius: 0.0, // 0.0 to 0.5
                                      ecLevel: "Q", // L, M, Q, H
                                      fill: "#536DFE", // foreground color
                                      background: null, // color or null for transparent
                                      size: 256, // in pixels
                                  }, container);
                              </script>
                          </body>
                      </html>
                  `;
        res.write(page);
        res.end();
      }
    }
    });
  }
  


client.on('ready', () => {
    console.log('Client is ready!');
  //  res.write("<html><body><h2>Client is ready!</h2></body></html>");
    //sendQr();
   
});

client.on('authenticated', () => {
    console.log('AUTHENTICATED');
   
});

app.get("/checkauth", async (req, res) => {
  client
    .getState()
    .then((data) => {
      console.log('Data' + data);
      res.send(data);
    })
    .catch((err) => {
      if (err) {
        res.send("DISCONNECTED");
      }
    });
});

// For Read Message
//client.on('message', message => {
//	console.log(message.body);
//});


app.param('phone', function(req, res, next, name) {
    const modified = name.toUpperCase();
  
    req.phone = modified;
    next();
  });

app.post('/sendmessage/:phone', async (req,res) => {
    let phone = req.params.phone;
    let smessage = req.body.message;
console.log(phone);
console.log(smessage);
    if (phone == undefined || smessage == undefined) {
        res.send({ status:"error", message:"please enter valid phone and message" })
    } else {
        client.sendMessage(phone + '@c.us', smessage).then((response) => {
            if (response.id.fromMe) {
                res.send({ status:'success', smessage: `Message successfully sent to ${phone}` })
            }
        });
    }
});


client.initialize();
